#include <stdio.h>
#include <stdlib.h>
#include <sys/ipc.h>
#include <time.h>
//#include <math.h>
#include "wisio.h"
#include "wappint.h"
int winc,mywin=0,secid,bmidx,clk;
int butc,Bclose,scroll,vscroll,hscroll,cid;
int Menu;

int sintbl[61];   
#define PI 3.1415926535 
#define MSIN(ang,tm) sintbl[(ang)%60]*tm/65536
#define MCOS(ang,tm) MSIN((ang)+15,(tm))

#define CH 63
#define CV 63

drawline(int cid, int x1, int y1, int x2, int y2, int width)
{
   unsigned dx,dy;
//   Wsetctl(mywin,SETCTL_COLOR_D,8,0);
   if (y2 != y1)
   {
      dx = abs(((x2-x1)<<16) / (y2 -y1));
      if (dx)
      {
         dy = (width<<16)/dx;
         dx = width*dx>>16;
      }
      else
         dy = width;
   }
   else
   {
      dx = width;
      dy = 0;
   }
   if (width==1)
      width++;
   if (abs(x2-x1) > abs (y2-y1))
   {
      dy = width/2;
      dx = 0;
   }
   else
   {
      dx = width/2;
      dy = 0;
   }
   Wsenddim(MAINQUE,CMD_ADDLIN,cid,0,x1-dx,y1-dy,ENDD);
   Wsenddim(MAINQUE,CMD_ADDLIN,cid,0,x2-dx,y2-dy,ENDD);
   Wsenddim(MAINQUE,CMD_ADDLIN,cid,0,x2+dx-1,y2+dy-1,ENDD);
   Wsenddim(MAINQUE,CMD_ADDLIN,cid,0,x1+dx-1,y1+dy-1,ENDD);
   Wsenddim(MAINQUE,CMD_ADDLIN,cid,0,x1-dx,y1-dy,ENDD);
   Wlog(7,"LINE %d,%d,(%d,%d)",x2-x1,y2-y1,dx,dy);
}
double sine(int angle)
{
    double x,x1,k,r,sg;
    int i;
    x=angle*PI/30;
    x1=x;
    k=1;
    sg=1;
    r=0;
    for (i= 1; i<20; i+=2)
    {
       r +=x1/k*sg;
       sg = -sg;
       x1 *= x*x;
       k *= (i+1)*(i+2);
    }   
    return r;
}

drawclock()
{
   int j;
   Wdelbar(mywin,0,0,MAXDIMVAL,MAXDIMVAL);
   Wsetctl(mywin,SETCTL_BTM,bmidx,0);
   for (j=0; j<60; j+=5)  
   {
      Waddtext(mywin,0,60+MCOS(j,50),60+MSIN(j,50),"\"");
   }
}
   
int showtime(int mywin, int min, int len)
{
   min-=15;
   Wsetctl(mywin,SETCTL_COLOR_D,8,0);
   Wsenddim(MAINQUE,CMD_ADDLIN,mywin,0,CH,CV,CH+MCOS(min-15,2),CV+MSIN(min-15,2),ENDD);
   Wsenddim(MAINQUE,CMD_ADDLIN,mywin,0,CH+MCOS(min-1,len/2),CV+MSIN(min-1,len/2),ENDD);
   Wsenddim(MAINQUE,CMD_ADDLIN,mywin,0,CH+MCOS(min,len),CV+MSIN(min,len),ENDD);
   Wsenddim(MAINQUE,CMD_ADDLIN,mywin,0,CH+MCOS(min+1,len/2),CH+MSIN(min+1,len/2),ENDD);
   Wsenddim(MAINQUE,CMD_ADDLIN,mywin,0,CH+MCOS(min+15,2),CH+MSIN(min+15,2),CH,CV,ENDD);
//   Wlog(18,"%d:(%d,%d)",min,MCOS(min,len),MSIN(min,len));
}

init(msg_win_cmd *pmes)
{  
   int wincid,j;
   winc = Wopenobj("Window");
   
   mywin =WAPnew(winc,pmes->cid,W_MENU+S_WINDOW,(10*mypid)%500,(10*mypid)%300,130,130,"  CLOCK");
   bmidx = Wgetbm("f16.font");
   
   Menu=Wsenddat(winc,CMD_WAPDTA,mywin,"Close",0,CTRL_HORISONT,1,ENDD);
//   cid =Waddctl(mywin,0,0,0,208,132);
   
   drawclock();
   secid=Waddctl(mywin,WINC_TRANS,0,0,130,130);
   Wsetctl(secid,SETCTL_COLOR_D,4,0);
   
   Wsetpar(PAR_TIMER,1000000);
}

int msgprocess()
{
   int len,/*xpos=0,ypos=0,*/clk,i,sec; 
   char *pdata,timestr[32];  
   time_t tp;
   struct tm *ptm;
   for(; ;)
   {
      msg_win_cmd mes;
      len=Wgetcmd(&mes);
      if (mywin)
      {
//         clk++;
         time(&tp);          
         ptm = localtime(&tp);
         sprintf(timestr,"  CLOCK %d:%02d.%02d",ptm->tm_hour,ptm->tm_min,ptm->tm_sec);
         WAPdata(mywin,winc,timestr ,0,0);
         i=ptm->tm_hour*60+ptm->tm_min;
         if (sec != ptm->tm_sec)
         {
            Wdelbar(secid,0,0,MAXDIMVAL,MAXDIMVAL);
            sec = ptm->tm_sec;
            drawline(secid,CH,CV,CH+MCOS(sec+45,52),CV+MSIN(sec+45,52),2);
//            showtime(secid,sec+60,52);
         }  
         if (i!= clk)
         {
            clk = i;
            drawclock();
            showtime(mywin,clk+60,50);
            showtime(mywin,clk/12+60,40);
         }
      }
      switch (mes.cmd)
      {
      case CMD_WAPNEW:
         init(&mes);
         break;
      case CMD_WAPUPD:
      case CMD_UPDCTL:
         if (mes.cid == mywin)
         {
            pdata = Wgetdata(&mes,&len);
            if (!strcmp(pdata,"Close"))
               Wsendcmd(MAINQUE,CMD_DELTSK,PEND);
         }
         break;
      case CMD_DELTSK:
         exit(0);
      }
   }
}


main(int argc,char *argv[])
{
   int i;
   
   Wloglevel =88;
   for (i=0; i<=15; i++)
   {
      sintbl[i]=(int)(sine(i)*65535.0);
      Wlog(24,"%d,%d",i,sintbl[i]);
   }
   for (i=16; i<=30; i++)
      sintbl[i]=sintbl[30-i];
   for (i=31; i<=60; i++)
      sintbl[i]=-sintbl[60-i];
   msgprocess();
}



